// If this code works, it was written by Svetlio Kapralov. If not, I don't know who wrote it.
package net.playerfinder.jsf.components.rating;

import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;

import javax.faces.application.ResourceDependencies;
import javax.faces.application.ResourceDependency;
import javax.faces.component.FacesComponent;
import javax.faces.component.UIInput;
import javax.faces.component.behavior.ClientBehaviorHolder;

@FacesComponent(UIRating.COMPONENT_TYPE)
@ResourceDependencies({
		@ResourceDependency(name = "jquery.js", library = "pfjs"),
		@ResourceDependency(name = "pf.no.conflicts.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.rateit.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.rateit.css", library = "css") })
public class UIRating extends UIInput implements ClientBehaviorHolder {

	public static final String COMPONENT_TYPE = "net.playerfinder.jsf.components.rating.UIRating";
	public static final String COMPONENT_FAMILY = "net.playerfinder.jsf.components";
	public static final String DEFAULT_RENDERER = "net.playerfinder.jsf.components.rating.UIRatingRenderer";

	private final static String DEFAULT_EVENT = "change";
	private static final Collection<String> EVENT_NAMES = Collections
			.unmodifiableCollection(Arrays.asList(DEFAULT_EVENT));

	protected enum PropertyKeys {
		score, totalStars, step, disabled;

		String toString;

		PropertyKeys(String toString) {
			this.toString = toString;
		}

		PropertyKeys() {
		}

		public String toString() {
			return ((this.toString != null) ? this.toString : super.toString());
		}
	}

	public UIRating() {
		setRendererType(DEFAULT_RENDERER);
	}

	public int getTotalStars() {
		return (java.lang.Integer) getStateHelper().eval(
				PropertyKeys.totalStars, 5);
	}

	public void setTotalStars(int totalStars) {
		getStateHelper().put(PropertyKeys.totalStars, totalStars);
	}

	public double getStep() {
		return (java.lang.Double) getStateHelper().eval(PropertyKeys.step, 1.0);
	}

	public void setStep(double step) {
		getStateHelper().put(PropertyKeys.step, step);
	}

	public boolean isDisabled() {
		return (java.lang.Boolean) getStateHelper().eval(PropertyKeys.disabled,
				false);
	}

	public void setDisabled(boolean disabled) {
		getStateHelper().put(PropertyKeys.disabled, disabled);
	}

	@Override
	public Collection<String> getEventNames() {
		return EVENT_NAMES;
	}

	@Override
	public String getDefaultEventName() {
		return DEFAULT_EVENT;
	}

	@Override
	public String getFamily() {
		return COMPONENT_FAMILY;
	}

}
